<?php

/**
 * @file
 * Contains \Drupal\metatag_user_role\Form\MetatagUserRoleDefaultsForm.
 */

namespace Drupal\metatag_user_role\Form;

use Drupal\metatag\Form\MetatagDefaultsForm;

/**
 * Class MetatagUserRoleDefaultsForm.
 *
 * @package Drupal\metatag_user_role\Form
 */
class MetatagUserRoleDefaultsForm extends MetatagDefaultsForm {

  /**
   * {@inheritdoc}
   */
  protected function getAvailableBundles() {
    // Get supported entity types.
    $entity_types = parent::getSupportedEntityTypes();
    // Get options from parent class.
    $options = parent::getAvailableBundles();
    // If User entity supported by Metatag module.
    if (isset($entity_types['user'])) {
      $entity_label = $entity_types['user'];
      /** @var \Drupal\Core\Entity\EntityTypeManagerInterface $entity_manager */
      $entity_manager = \Drupal::service('entity_type.manager');
      /** @var \Drupal\Core\Entity\EntityTypeBundleInfoInterface $bundle_info */
      $bundles = \Drupal::service('entity_type.bundle.info')->getBundleInfo('user');
      $metatags_defaults_manager = $entity_manager->getStorage('metatag_defaults');

      foreach ($bundles as $bundle_id => $bundle_metadata) {
        // Load user roles.
        foreach (_metatag_user_role_user_roles() as $role) {
          $metatag_defaults_id = 'user__' . $bundle_id . '__role__' . $role->id();
          // Put new options.
          if (empty($metatags_defaults_manager->load($metatag_defaults_id))) {
            $options[$entity_label][$metatag_defaults_id] = "{$bundle_metadata['label']} by role: {$role->label()}";
          }
        }
      }
    }
    return $options;
  }

}
